/* DATA */
var rythm = [];
rythm.push(['r1','./assets/r1.mp3','./assets/forme_biere.png']);
rythm.push(['r2','./assets/r2.mp3','./assets/forme_canna.png']);
rythm.push(['r3','./assets/r3.mp3','./assets/forme_skull.png']);
rythm.push(['r4','./assets/r4.mp3','./assets/forme-platine.png']);
var bass = [];
bass.push(['b1','./assets/b1.mp3','./assets/texture_feuille.png']);
bass.push(['b2','./assets/b2.mp3','./assets/texture_herbe.png']);
bass.push(['b3','./assets/b3.mp3','./assets/texture_plectre.png']);
bass.push(['b4','./assets/b4.mp3','./assets/texture_tache.png']);
var melody = [];
melody.push(['m1','./assets/m1.mp3','0']);
melody.push(['m2','./assets/m2.mp3','70']);
melody.push(['m3','./assets/m3.mp3','150']);
melody.push(['m4','./assets/m4.mp3','240']);

/* Vars */
var characterWidth=document.getElementById('sourceCharacter').width;
var characterHeight=document.getElementById('sourceCharacter').height;
//var gameHeight=Math.floor(window.innerHeight/2.5);
//var pickHeight=Math.floor(window.innerHeight/4);
var playZoneWidth=document.getElementById('game').clientWidth;
var playZoneHeight=document.getElementById('game').clientHeight;
var gameHeight=Math.floor(playZoneHeight/2.5);
var pickHeight=Math.floor(playZoneHeight/4);

var pickCount=1;

function initCharacters(){

  var characters=document.getElementsByClassName('character');
  for(i=0;i<characters.length;i++){
    characters[i].style.top=gameHeight;
    characters[i].style.left=Math.floor(((playZoneWidth-characterWidth)/(characters.length-1))*i);
  }
  var clickables=document.getElementsByClassName('clickable');
  for(i=0;i<clickables.length;i++){
    clickables[i].style.top=pickHeight;
    clickables[i].addEventListener('click',pickCharacter);
  }
  function pickCharacter(e){
    if(e.target.classList.contains('clickable')){
      e.target.style.left=Math.floor(((playZoneWidth-characterWidth)/(characters.length-1))*pickCount);
      e.target.style.top=gameHeight;
      e.target.classList.remove('clickable');
      pickCount++;
    }
    if(clickables.length==0){
      startGame();
    }
  }
  return characters;
}

function initIdea(){
  var idea = [rythm[Math.floor(Math.random()*rythm.length)],bass[Math.floor(Math.random()*bass.length)],melody[Math.floor(Math.random()*melody.length)]];
  return idea;
}

function showIdea(idea){
  var ideaDiv=document.getElementById('idea');
  var img=document.createElement('img');
  img.src=idea[0][2];
  img.style.mask='url('+idea[1][2]+') 100% 100% add';
  img.style.filter='sepia(100%) hue-rotate('+idea[2][2]+'deg) saturate(500%)';
  ideaDiv.appendChild(img);
  ideaDiv.style.top=gameHeight-ideaDiv.clientHeight;
  ideaDiv.style.left=characterWidth;
}

function startGame(){
  for(i=0;i<characters.length;i++){
    playIdea();
    transmitIdea();
    modifyIdea();
  }
}

function playIdea(){

  var snd1  = new Audio();
  var src1  = document.createElement("source");
  src1.type = "audio/mpeg";
  src1.src  = idea[0][1];
  snd1.appendChild(src1);

  var snd2  = new Audio();
  var src2  = document.createElement("source");
  src2.type = "audio/mpeg";
  src2.src  = idea[1][1];
  snd2.appendChild(src2);

  var snd3  = new Audio();
  var src3  = document.createElement("source");
  src3.type = "audio/mpeg";
  src3.src  = idea[2][1];
  snd3.appendChild(src3);

  snd1.play(); snd2.play(); snd3.play(); //this is synchronised ?

}

function transmitIdea(){
  console.log('transmit');
}

function modifyIdea(){
  console.log('modify');
}

var characters=initCharacters();
var idea=initIdea();
showIdea(idea);
